import urllib2
from Malcom.model.datatypes import Ip, Evil
from feed import Feed
import Malcom.auxiliary.toolbox as toolbox

class DShield3215(Feed):
	"""
	This gets data from http://dshield.org/asdetailsascii.html?as=3215
	"""
	def __init__(self, name):
		super(DShield3215, self).__init__(name)
		self.name = "DShield3215"
		self.source = 'http://dshield.org/asdetailsascii.html?as=3215'
		self.description = "DShield scanning report for AS 3215"
		self.confidence = 30
		

	def update(self):
		self.update_lines()

	def analyze(self, line):
		if line.startswith('#') or line.startswith('\n'):
			return
		dict = line.split('\t')
		if int(dict[2]) < 300: # skip entries which have not been reported at least 300 times
			return

		try:
			ip = toolbox.find_ips(line)[0]
		except Exception, e:
			# if find_ip raises an exception, it means no ip 
			# was found in the line, so we return
			return

		# Create the new ip and store it in the DB
		dict = line.split('\t')
		ip = Ip(ip=ip, tags=['dshield'])
		evil = Evil()
		evil['value'] = 'Scanner at %s' % ip['value']
		evil['reports'] = dict[2]
		evil['first seen'] = dict[3]
		evil['last seen'] = dict[4]

		return ip, evil



