import urllib2
from Malcom.model.datatypes import Url 
from feed import Feed
import Malcom.auxiliary.toolbox as toolbox

class MalwarePatrolVX(Feed):
	"""
	This gets data from http://www.malwarepatrol.net/cgi/submit?action=list 
	"""
	def __init__(self, name):
		super(MalwarePatrolVX, self).__init__(name, run_every="1h")
		self.name = "MalwarePatrolVX"
		self.source = 'http://www.malwarepatrol.net/cgi/submit?action=list'
		self.descriptin = ""
		

	def update(self):
		feed = urllib2.urlopen(self.source).readlines()
		self.status = "OK"
		
		for line in feed:	
			self.analyze(line)
		return True

	def analyze(self, line):
		if line.startswith('#') or line.startswith('\n'):
			return

		try:
			url = toolbox.find_urls(line)[0]
		except Exception, e:
			# if find_urls raises an exception, it means no ip was found in the line, so we return
			return

		# Create the new ip and store it in the DB
		url =Url(url=url, tags=['malwarepatrol'])

		url, new = self.model.save(url, with_status=True)
		if new:
			self.elements_fetched += 1


