import urllib2
import datetime, re
from lxml import etree
import Malcom.auxiliary.toolbox as toolbox
from bson.objectid import ObjectId
from bson.json_util import dumps
from Malcom.model.datatypes import Evil, Url
from feed import Feed

class MalwaredRu(Feed):

	def __init__(self, name):
		super(MalwaredRu, self).__init__(name, run_every="1h")
		self.enabled = True

	def update(self):
		try:
			feed = urllib2.urlopen("http://malwared.malwaremustdie.org/rss.php")
			self.status = "OK"
		except Exception, e:
			self.status = "ERROR: " + str(e)
			return False

	# <item><title>Solar</title><description>Mar/2014</description><link>http://...</link></item>

		children = ["title", "description", "link"]
		main_node = "item"
		
		tree = etree.parse(feed)
		for item in tree.findall("//%s"%main_node):
			dict = {}
			for field in children:
				dict[field] = item.findtext(field)

			self.analyze(dict)

		return True

	def analyze(self, dict):
		try:
			url = toolbox.find_urls(dict['link'])[0]
		except Exception, e:
			return

		# Create the new url and store it in the DB
		url =Url(url=url, tags=['Malwared.ru', 'malware', dict['title'].lower()])

		url, status = self.analytics.save_element(url, with_status=True)
		if status['updatedExisting'] == False:
			self.elements_fetched += 1
